SystemOrganization addCategory: #'Coral-Examples-Esug2011'!

Object subclass: #Ansi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Examples-Esug2011'!

!Ansi class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/21/2011 17:55'!
bg: sgrColorIndex
	^ self sgr: '48;5;' , sgrColorIndex asString! !

!Ansi class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/21/2011 19:25'!
clearScreen
	^ (self esc: '[f') , (self esc: '[J')! !

!Ansi class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/21/2011 21:42'!
esc: aString
	^ aString copyWithFirst: Character escape! !

!Ansi class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/15/2011 11:26'!
fg: sgrColorIndex
	^ self sgr: '38;5;' , sgrColorIndex asString! !

!Ansi class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/12/2011 21:57'!
sgr: sgrParameterString
	^ (String with: Character escape with: $[) ,
		sgrParameterString ,
		'm'! !

!Ansi class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/12/2011 21:57'!
sgr: codes sgr: moreCodes
	^ (self sgr: codes) , (self sgr: moreCodes)! !

!Ansi class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/12/2011 21:58'!
sgrReset
	^ self sgr: '0'! !

Object subclass: #CoralEsug2011Talk
	instanceVariableNames: 'colorizeMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Examples-Esug2011'!

!CoralEsug2011Talk class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/12/2011 21:56'!
colorizeMapSolarized
	^ {
		$Y -> (Ansi sgr: '38;5;3' sgr: '48;5;3').
		$O -> (Ansi sgr: '38;5;9' sgr: '48;5;9').
		$R -> (Ansi sgr: '38;5;1' sgr: '48;5;1').
		$M -> (Ansi sgr: '38;5;5' sgr: '48;5;5').
		$P -> (Ansi sgr: '38;5;13' sgr: '48;5;13').
		$B -> (Ansi sgr: '38;5;4' sgr: '48;5;4').
		$C -> (Ansi sgr: '38;5;6' sgr: '48;5;6').
		$G -> (Ansi sgr: '38;5;2' sgr: '48;5;2').
	}! !

!CoralEsug2011Talk class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/12/2011 21:50'!
solarized
	^ self new colorizeMap: self colorizeMapSolarized! !

!CoralEsug2011Talk methodsFor: 'utilities' stamp: 'DamienPollet 8/12/2011 21:58'!
ansiColorize: aString colorMap: colorMap
	"Surround contiguous sequences of some characters in aString with ANSI color codes.
	colorMap is an Array of Associations mapping characters to the desired ANSI color number"
	
	^ colorMap inject: aString into: [ :img :map |
		| pattern |
		pattern := String with: map key with: $+.
		(RxMatcher forString: pattern)
			copy: img
			translatingMatchesUsing: [ :substring | map value , substring , Ansi sgrReset ] ]! !

!CoralEsug2011Talk methodsFor: 'utilities' stamp: 'DamienPollet 8/12/2011 21:50'!
colorize: aString
	^ self ansiColorize: aString colorMap: colorizeMap! !

!CoralEsug2011Talk methodsFor: 'initialization' stamp: 'DamienPollet 8/12/2011 21:49'!
colorizeMap: aMap
	colorizeMap := aMap! !

!CoralEsug2011Talk methodsFor: 'data' stamp: 'DamienPollet 8/12/2011 21:59'!
edinburghLogo
	^ self colorize: '
                                                       YYYY
                                                 RRRRRYYYYYYYBBBBC
                                              PPRRRRRYYYYYYYYBBBBBCCC
                                             PPRRRRRRYYYYYYYYYBBBBBCCC
                                            PPPRRRRRRYYYYYYYYYBBBBBCCCC
                                            PPPRRRRRRYYYYYYYYYBBBBBCCCC
                                            PPPRRRRRRYYYYYYYYBBBBBBCCCC
                                            PPPPRRRRRYYYYYYYYBBBBBBCCCC
                                             PPPRRRRRRYYYYYYYBBBBBCCCC
                                              PPPRRRRRYYYYYYYBBBBBCCC
                                               PPPRRRRYYYYYYBBBBBCCC
                                                PPPRRRRYYYYYBBBBCCC
                                                 PPPRRRYYYYYBBBCC
                                                   PPRRYYYYBBBCC
                                                    PPRRYYYBBC
                                                     PRRYYYBC

                                                       B B B
                             BBB  BBB                  B B B
                        BBB  BBB  BBB  BBB
                         BBBBBBBBBBBBBBBB
     BBB  BBB             BBBBBBBBBBBBBB             BBB  BBB
BBB  BBB  BBB  BBB         BBBBBBBBBBBB         BBB  BBB  BBB  BBB
 BBBBBBBBBBBBBBBB          BBBBBBBBBBBB          BBBBBBBBBBBBBBBB
  BBBBBBBBBBBBBB           BBBBBBBBBBBB           BBBBBBBBBBBBBB
   BBBBBBBBBBBB  BBB  BBB  BBBBBBBBBBBB  BBB  BBB  BBBBBBBBBBBB
   BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
   BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
   BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
   BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
   BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
   BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
  BBBBBBBBBBBBBBBBBBBBBBBBBBBB      BBBBBBBBBBBBBBBBBBBBBBBBBBBB
  BBBBBBBBBBBBBBBBBBBBBBBBBB          BBBBBBBBBBBBBBBBBBBBBBBBBB
 BBBBBBBBBBBBBBBBBBBBBBBBBBB          BBBBBBBBBBBBBBBBBBBBBBBBBBB
BBBBBBBBBBBBBBBBBBBBBBBBBBBB          BBBBBBBBBBBBBBBBBBBBBBBBBBBB
BBBBBBBBBBBBBBBBBBBBBBBBBBBB          BBBBBBBBBBBBBBBBBBBBBBBBBBBB
BBBBBBBBBBBBBBBBBBBBBBBBBBBB          BBBBBBBBBBBBBBBBBBBBBBBBBBBB
' withUnixLineEndings! !

Object subclass: #CoralGrowingDemo
	instanceVariableNames: 'width height heights delay finished'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Examples-Esug2011'!

!CoralGrowingDemo class methodsFor: 'instance creation' stamp: 'DamienPollet 8/21/2011 18:48'!
new
	^ self
		width: (OSProcess thisOSProcess environment at: #COLUMNS ifAbsent: [0]) asNumber
		height: (OSProcess thisOSProcess environment at: #LINES ifAbsent: [0]) asNumber! !

!CoralGrowingDemo class methodsFor: 'instance creation' stamp: 'DamienPollet 8/21/2011 18:32'!
width: width height: height
	^ self basicNew initializeWidth: width height: height! !

!CoralGrowingDemo methodsFor: 'animation' stamp: 'DamienPollet 8/22/2011 10:51'!
animate
	| left right |
	left := right := width atRandom.
	[ finished ]
		whileFalse: [ | where |
			where := (left to: right) atRandom.
			self dropIn: where.
			left := (left min: where - 1) max: 1.
			right := (right max: where + 1) min: width.
			delay ifNotNil: [ delay wait ] ]! !

!CoralGrowingDemo methodsFor: 'animation' stamp: 'DamienPollet 8/22/2011 10:50'!
dropIn: aColumn
	| landing |

	landing := (heights at: aColumn) - 1.
	aColumn > 1
		ifTrue: [ landing := landing min: (heights at: aColumn - 1) - 1 ].
	aColumn < width
		ifTrue: [ landing := landing min: (heights at: aColumn + 1) - 1 ].

	heights at: aColumn put: landing.
	Console locate: (aColumn * 2 - 1) @ (landing); print: '  '.

	landing <= 0
		ifTrue: [ finished := true ]
	! !

!CoralGrowingDemo methodsFor: 'accessing' stamp: 'DamienPollet 8/21/2011 19:00'!
frameDelay: aDelay
	delay := aDelay! !

!CoralGrowingDemo methodsFor: 'initialization' stamp: 'DamienPollet 8/22/2011 10:50'!
initializeWidth: w height: h
	width := w // 2.
	height := h.
	heights := Array new: width withAll: height.
	finished := false! !

Object subclass: #Slide
	instanceVariableNames: 'title action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Examples-Esug2011'!

Slide subclass: #ExtensionSlide
	instanceVariableNames: 'previous'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Examples-Esug2011'!

!ExtensionSlide class methodsFor: 'instance creation' stamp: 'DamienPollet 8/22/2011 15:45'!
on: aSlide with: aBlock
	^ self new
		previous: aSlide;
		action: aBlock! !

!ExtensionSlide methodsFor: 'testing' stamp: 'DamienPollet 8/22/2011 16:33'!
isPartial
	^ true! !

!ExtensionSlide methodsFor: 'accessing' stamp: 'DamienPollet 8/22/2011 15:46'!
previous: aSlide
	previous := aSlide! !

!ExtensionSlide methodsFor: 'displaying' stamp: 'DamienPollet 8/22/2011 15:47'!
projectOn: aScreen
	previous projectOn: aScreen.
	action value: aScreen! !

!Slide class methodsFor: 'instance creation' stamp: 'DamienPollet 8/15/2011 07:52'!
titled: aString with: aBlock
	^ self new
		title: aString;
		action: aBlock! !

!Slide methodsFor: 'accessing' stamp: 'DamienPollet 8/15/2011 07:53'!
action: aBlock
	action := aBlock! !

!Slide methodsFor: 'testing' stamp: 'DamienPollet 8/22/2011 16:32'!
isPartial
	^ false! !

!Slide methodsFor: 'displaying' stamp: 'DamienPollet 8/21/2011 18:10'!
projectOn: aScreen
	aScreen clearSlide.
	action value: aScreen
	! !

!Slide methodsFor: 'accessing' stamp: 'DamienPollet 8/15/2011 07:44'!
title: aString
	title := aString! !

Slide subclass: #TextSlide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Examples-Esug2011'!

!TextSlide methodsFor: 'displaying' stamp: 'DamienPollet 8/21/2011 18:10'!
projectOn: aScreen
	aScreen clearSlide.
	aScreen title: title.
	action value: aScreen! !

Object subclass: #SlideDeck
	instanceVariableNames: 'slides name index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Examples-Esug2011'!

!SlideDeck class methodsFor: 'instance creation' stamp: 'DamienPollet 8/15/2011 07:36'!
named: aString
	^ self basicNew initializeWithName: aString! !

!SlideDeck methodsFor: 'accessing' stamp: 'DamienPollet 8/15/2011 07:43'!
addSlide: aSlide
	^ slides add: aSlide! !

!SlideDeck methodsFor: 'slides-creation' stamp: 'DamienPollet 8/21/2011 16:58'!
blankSlide: title with: aBlock
	^ self addSlide: (Slide titled: title with: aBlock)! !

!SlideDeck methodsFor: 'displaying' stamp: 'DamienPollet 8/22/2011 16:36'!
goToFirst
	index := 1! !

!SlideDeck methodsFor: 'displaying' stamp: 'DamienPollet 8/22/2011 16:36'!
goToLast
	index := slides size! !

!SlideDeck methodsFor: 'displaying' stamp: 'DamienPollet 8/22/2011 16:37'!
goToNext
	index := index + 1! !

!SlideDeck methodsFor: 'displaying' stamp: 'DamienPollet 8/22/2011 16:38'!
goToPrevious
	[ self goToPreviousPartial ]
		doWhileTrue: [ (slides at: index) isPartial ]! !

!SlideDeck methodsFor: 'displaying' stamp: 'DamienPollet 8/22/2011 16:43'!
goToPreviousPartial
	index := (index - 1) max: 1! !

!SlideDeck methodsFor: 'initialization' stamp: 'DamienPollet 8/15/2011 07:36'!
initializeWithName: aString
	slides := OrderedCollection new.
	name := aString! !

!SlideDeck methodsFor: 'slides-creation' stamp: 'DamienPollet 8/22/2011 15:44'!
previousWith: aBlock
	^ self addSlide: (ExtensionSlide on: slides last with: aBlock)! !

!SlideDeck methodsFor: 'displaying' stamp: 'DamienPollet 8/23/2011 11:29'!
projectOn: aScreen

	self goToFirst.
	[ index <= slides size ] whileTrue: [ | cmd |
		(slides at: index) projectOn: aScreen.
		cmd := aScreen readOneCharacter.
		
		('qQ' includes: cmd) ifTrue: [ aScreen clearSlide. ^ self ].
		('1{' includes: cmd) ifTrue: [ self goToFirst ].
		('0}' includes: cmd) ifTrue: [ self goToLast ].
		(' n]' , String lf includes: cmd) ifTrue: [ self goToNext ].
		('p[' includes: cmd) ifTrue: [ self goToPrevious ].
		('P' includes: cmd) ifTrue: [ self goToPreviousPartial ].
		].
	aScreen clearSlide.
	aScreen display: 'Thanks for your attention!!'! !

!SlideDeck methodsFor: 'slides-creation' stamp: 'DamienPollet 8/21/2011 16:59'!
slide: title with: aBlock
	^ self addSlide: (TextSlide titled: title with: aBlock)! !

!SlideDeck methodsFor: 'displaying' stamp: 'DamienPollet 8/15/2011 10:39'!
slideshow
	self projectOn: (SlideScreen on: Console)! !

Object subclass: #SlideScreen
	instanceVariableNames: 'stream margin width height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Examples-Esug2011'!

!SlideScreen class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/15/2011 11:01'!
on: aStream
	^ self new stream: aStream! !

!SlideScreen methodsFor: 'displaying-primitives' stamp: 'DamienPollet 8/21/2011 17:57'!
ansiColorize: aString color: ansiColor
	"Surround contiguous sequences of some characters in aString with ANSI color codes.
	colorMap is an Array of Associations mapping characters to the desired ANSI color number"
	
	^ (RxMatcher forString: '#+')
		copy: aString
		translatingMatchesUsing: [ :substring | ansiColor , substring , Ansi sgrReset ]! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/21/2011 18:15'!
bigFiglet: aString
	^ OSProcess thisOSProcess waitForCommandOutput: 'figlet -d /opt/homebrew/share/figlet/fonts/bdffonts -f xtty -k "' , aString , '"'! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/15/2011 14:01'!
blue: aBlock
	self fg: 4 do: aBlock! !

!SlideScreen methodsFor: 'displaying-primitives' stamp: 'DamienPollet 8/21/2011 18:04'!
center: aString
	^ Character lf join: (
		(Character lf split: aString)
			collect: [ :each | self centerSingle: each ])
	! !

!SlideScreen methodsFor: 'displaying-primitives' stamp: 'DamienPollet 8/21/2011 18:02'!
centerSingle: aString
	| spaces |
	spaces := (width - aString size) // 2.
	^ spaces = 0
		ifTrue: [ aString ]
		ifFalse: [ (String new: spaces withAll: Character space) , aString ]
	! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/21/2011 18:04'!
centered: aString
	self display: (self center: aString)! !

!SlideScreen methodsFor: 'displaying-primitives' stamp: 'DamienPollet 8/21/2011 19:24'!
clearSlide
	stream << Ansi clearScreen.
	self resetMargin! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/22/2011 13:51'!
columns: aCollection
	^ (OSProcess thisOSProcess
				command: 'column -c ' , width asString
				input: (Character lf join: aCollection))
			output! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/15/2011 14:04'!
cyan: aBlock
	self fg: 6 do: aBlock! !

!SlideScreen methodsFor: 'displaying-primitives' stamp: 'DamienPollet 8/21/2011 17:24'!
display: aString
	self skipMargin.
	stream << aString; newline! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/15/2011 14:03'!
fg: n do: aBlock
	stream << (Ansi fg: n).
	aBlock cull: self.
	stream << Ansi sgrReset! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/15/2011 14:04'!
green: aBlock
	self fg: 2 do: aBlock! !

!SlideScreen methodsFor: 'initialization' stamp: 'DamienPollet 8/21/2011 18:46'!
initialize
	margin := 0.
	width := (OSProcess thisOSProcess environment at: #COLUMNS ifAbsent: [0]) asNumber.
	height := (OSProcess thisOSProcess environment at: #LINES ifAbsent: [0]) asNumber! !

!SlideScreen methodsFor: 'displaying-content' stamp: 'DamienPollet 8/23/2011 11:34'!
item: aString
	self text: '      * ' , aString! !

!SlideScreen methodsFor: 'displaying-content' stamp: 'DamienPollet 8/22/2011 15:58'!
logo: aString
	| orange |
	orange := (Ansi fg: 9) , (Ansi bg: 9).
	self margin: 5.
	stream << (self
					ansiColorize: (self center: (self bigFiglet: aString))
					color: orange).
	self margin: 3! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/15/2011 14:04'!
magenta: aBlock
	self fg: 5 do: aBlock! !

!SlideScreen methodsFor: 'displaying-primitives' stamp: 'DamienPollet 8/15/2011 10:36'!
margin: anInteger
	margin := margin max: anInteger! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/15/2011 14:05'!
orange: aBlock
	self fg: 9 do: aBlock! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/15/2011 14:05'!
purple: aBlock
	self fg: 13 do: aBlock! !

!SlideScreen methodsFor: 'interaction' stamp: 'DamienPollet 8/15/2011 12:49'!
readOneCharacter
	^ stream readOneCharacter! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/15/2011 14:05'!
red: aBlock
	self fg: 1 do: aBlock! !

!SlideScreen methodsFor: 'displaying-primitives' stamp: 'DamienPollet 8/15/2011 10:38'!
resetMargin
	margin := 0! !

!SlideScreen methodsFor: 'displaying-primitives' stamp: 'DamienPollet 8/22/2011 14:43'!
skipMargin
	margin timesRepeat: [ stream newline ].
	self resetMargin.! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/21/2011 17:12'!
smallFiglet: aString
	^ OSProcess thisOSProcess waitForCommandOutput: 'figlet -f small "' , aString , '"'! !

!SlideScreen methodsFor: 'initialization' stamp: 'DamienPollet 8/15/2011 11:01'!
stream: aStream
	stream := aStream! !

!SlideScreen methodsFor: 'displaying-content' stamp: 'DamienPollet 8/23/2011 11:34'!
subitem: aString
	self text: '         - ' , aString! !

!SlideScreen methodsFor: 'displaying-content' stamp: 'DamienPollet 8/21/2011 18:06'!
subtitle: aString
	self margin: 3.
	self centered: aString.
	self margin: 2! !

!SlideScreen methodsFor: 'displaying-content' stamp: 'DamienPollet 8/23/2011 11:36'!
text: aString
	self white: [	self display: '   ' , aString ]! !

!SlideScreen methodsFor: 'displaying-content' stamp: 'DamienPollet 8/21/2011 18:12'!
title: aString
	| green |
	green := (Ansi fg: 2) , (Ansi bg: 2).
	self margin: 1.
	stream << (self
					ansiColorize: (self center: (self bigFiglet: aString))
					color: green).
	self margin: 2! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/15/2011 14:05'!
white: aBlock
	self fg: 7 do: aBlock! !

!SlideScreen methodsFor: 'displaying-appearance' stamp: 'DamienPollet 8/15/2011 14:06'!
yellow: aBlock
	self fg: 3 do: aBlock! !
